@echo off

 rem ***************************************************************************
 rem * NOTEPAD_RESET.BAT
 rem *
 rem * This batch file will restore Windows Notepad 'Notepad.exe'
 rem * from backup copy 'Notepad.exe.bak'. Backup copy is expected to be in the
 rem * same folder as Notepad.
 rem *
 rem * USAGE  : NOTEPAD_RESET.BAT
 rem * History: Mar 13, 2006 - fixed for Windows XP SP2 & Server 2003
 rem *
 rem * Copyright  Igor Zenkov 2004 - 2006
 rem ***************************************************************************

:start

 set ver=1.1

 set copy_bak=%SystemRoot%\notepad.exe.bak
 set copy_win=%SystemRoot%\notepad.exe
 set copy_sys=%SystemRoot%\system32\notepad.exe
 set copy_dll=%SystemRoot%\system32\dllcache\notepad.exe
 set copy_sp2=%SystemRoot%\ServicePackFiles\i386\notepad.exe
 
:logo

 echo NOTEPAD_RESET.BAT %ver% - Windows Notepad restorer command file
 echo Copyright (c) 2004 - 2006 Igor P. Zenkov (www.zenkov.com)
 echo.

:chk_backup

 if not exist %copy_bak% goto err_backup
 
:copy_files

 echo Restoring Windows Notepad from '%copy_bak%' ...
 echo.

:copy_sp2

 if not exist %copy_sp2% goto copy_dll
 echo .Updating %copy_sp2%
 copy %copy_bak% %copy_sp2%
 if errorlevel 1 goto err_copy_sp2

:copy_dll

 if not exist %copy_dll% goto copy_sys
 echo .Updating %copy_dll%
 copy %copy_bak% %copy_dll%
 if errorlevel 1 goto err_copy_dll

:copy_sys

 if not exist %copy_sys% goto copy_win
 echo .Updating %copy_sys%
 copy %copy_bak% %copy_sys%
 if errorlevel 1 goto err_copy_sys
 
:copy_win

 if not exist %copy_win% goto err_not_found
 echo .Updating %copy_win%
 copy %copy_bak% %copy_win%
 if errorlevel 1 goto err_copy_win
 
:del_backup

 echo .Deleting %copy_bak%
 del %copy_bak%
 if errorlevel 1 goto err_del

 echo.
 echo Success!
 goto end
 
:err_backup
 echo ERROR: Unable to find a backup file '%copy_bak%'
 goto end

:err_copy_win
 echo ERROR: Unable to replace '%copy_win%'
 goto end

:err_copy_sys
 echo ERROR: Unable to replace '%copy_sys%'
 goto end

:err_copy_dll
 echo ERROR: Unable to replace '%copy_dll%'
 goto end

:err_copy_sp2
 echo ERROR: Unable to replace '%copy_sp2%'
 goto end

:err_del
 echo ERROR: Unable to delete '%copy_bak%'
 goto end

:err_not_found
 echo ERROR: Unable to find 'Notepad.exe'

:end

pause

