@echo off

 rem ***************************************************************************
 rem * NOTEPAD_SET.BAT
 rem *
 rem * This batch file will replace Windows Notepad with different text editor
 rem * Original 'Notepad.exe' will be saved as 'Notepad.exe.bak' in the same
 rem * folder. Original Notepad can be restored by running NOTEPAD_RESET.BAT
 rem *
 rem * USAGE  : NOTEPAD_SET.BAT <abc.exe>
 rem * EXAMPLE: NOTEPAD_SET.BAT TE.exe
 rem * History: Mar 13, 2006 - fixed for Windows XP SP2 & Server 2003
 rem *
 rem * Copyright  Igor Zenkov 2004 - 2006
 rem ***************************************************************************

:start

 set ver=1.1
 
 set copy_bak=%SystemRoot%\notepad.exe.bak
 set copy_win=%SystemRoot%\notepad.exe
 set copy_sys=%SystemRoot%\system32\notepad.exe
 set copy_dll=%SystemRoot%\system32\dllcache\notepad.exe
 set copy_sp2=%SystemRoot%\ServicePackFiles\i386\notepad.exe
 
:logo

 echo NOTEPAD_SET.BAT %ver% - Windows Notepad replacement command file
 echo Copyright (c) 2004 - 2006 Igor P. Zenkov (www.zenkov.com)
 echo.

:chk_params

 if [%1]==[] goto err_param

 echo Replacing Windows Notepad with '%1' ...
 echo.

:backup

 if exist %copy_bak% goto copy_files
 echo .Saving '%copy_win%' as '%copy_bak%'
 copy %copy_win% %copy_bak%
 if errorlevel 1 goto err_backup

:copy_files

:copy_sp2

 if not exist %copy_sp2% goto copy_dll
 echo .Updating %copy_sp2%
 copy %1 %copy_sp2%
 if errorlevel 1 goto err_copy_sp2

:copy_dll

 if not exist %copy_dll% goto copy_sys
 echo .Updating %copy_dll%
 copy %1 %copy_dll%
 if errorlevel 1 goto err_copy_dll
 
:copy_sys

 if not exist %copy_sys% goto copy_win
 echo .Updating %copy_sys%
 copy %1 %copy_sys%
 if errorlevel 1 goto err_copy_sys

:copy_win

 if not exist %copy_win% goto err_not_found
 echo .Updating %copy_win%
 copy %1 %copy_win%
 if errorlevel 1 goto err_copy_win

 echo.
 echo Success!
 goto end
 
:err_param
 echo.
 echo ERROR: File name parameter expected
 echo Example: SET_NOTEPAD TE.exe
 goto end

:err_backup
 echo.
 echo ERROR: Unable to backup '%copy_win%' to '%copy_bak%'
 goto end

:err_copy_win
 echo.
 echo ERROR: Unable to replace '%copy_win%'
 goto end

:err_copy_sys
 echo.
 echo ERROR: Unable to replace '%copy_sys%'
 goto end

:err_copy_dll
 echo.
 echo ERROR: Unable to replace '%copy_dll%'
 goto end

:err_copy_sp2
 echo.
 echo ERROR: Unable to replace '%copy_sp2%'
 goto end
 
:err_not_found
 echo.
 echo ERROR: Unable to find 'Notepad.exe'

:end

